import { QueryBuilder } from "../queryBuilder";
import { IPagination } from "../global/interface";
import { IIdentifiable } from "../models/interfaces/IIdentifiable";
import { Request } from "../global/types/express";
import { ExpandItemFilterString } from "./interfaces/IQueryCRUD";
import { WithRelation } from "../queryBuilder/interfaces/WithRelation";
import { AbstractHttpController } from "./AbstractHttpController";
import { DBConnection } from "../connections/types";
export declare class CRUDController<T extends IIdentifiable> extends AbstractHttpController {
    readonly queryBuilder: QueryBuilder<T>;
    constructor(queryBuilder: QueryBuilder<T>);
    protected get dbConnection(): DBConnection;
    getQueries(req: Request, queriesString: string): import("../..").QueryCondition<import("../..").ModelQuery<T>>;
    getPagination(req: Request): IPagination;
    getWith(req: Request, _with: any[], queryBuilder?: QueryBuilder<any>, deep?: number): any[];
    getOperatorFilter(req: Request, operatorFilter: string, queryBuilder?: QueryBuilder<any>): import("../..").QueryCondition<any>;
    getOperatorWith(req: Request, _with: ExpandItemFilterString[], queryBuilder?: QueryBuilder<any>, deep?: number): WithRelation<any, any>[];
    get(req: Request): Promise<{
        data: import("../..").ModelQuery<T>[];
        totalCount: number;
    }>;
    create(req: Request): Promise<{
        data: import("../..").ModelQuery<T>;
    }>;
    update(req: Request): Promise<{
        data: import("../..").ModelQuery<T>[];
    }>;
    delete(req: Request): Promise<{
        status: boolean;
        data: any;
    }>;
}
