import { ObjectId, ClientSession } from "mongodb";
import { WithRelation } from "./WithRelation";
import { FindOptions, ModelQuery, QueryCondition, SelectColumns } from "./QueryCondition";
import { QueryBuilder } from "..";
import { IPagination } from "../../global";
import { Transaction as TransSequelize } from "sequelize";
export interface OptionTransaction {
    transaction?: ClientSession | TransSequelize;
}
export interface IQueryBuilder<T> {
    withRelations: WithRelation<T, any>[];
    selectColumns: SelectColumns<T>;
    with<K>(params: WithRelation<T, K> | WithRelation<T, K>[], model: QueryBuilder<T>): any;
    findByPk(pk: ObjectId | string | number): Promise<ModelQuery<T> | null>;
    find(filter: QueryCondition<ModelQuery<T>>, options?: FindOptions<ModelQuery<T>>): Promise<ModelQuery<T>[]>;
    paginate(filter: QueryCondition<ModelQuery<T>>, paginate: IPagination, options?: FindOptions<ModelQuery<T>>): Promise<{
        data: ModelQuery<T>[];
        totalCount: number;
    }>;
    count(filter: QueryCondition<ModelQuery<T>>): Promise<number>;
    createOne(item: Partial<ModelQuery<T>>, options?: OptionTransaction): Promise<ModelQuery<T>>;
    updateMany(filter: QueryCondition<ModelQuery<T>>, item: Partial<ModelQuery<T>>, options?: OptionTransaction): any;
    deleteOne(filter: QueryCondition<ModelQuery<T>>, options?: OptionTransaction): any;
    deleteMany(filter: QueryCondition<ModelQuery<T>>, options?: OptionTransaction): any;
    select(selectColumns: SelectColumns<T>): any;
    reset(): any;
}
